/*
 ķ
   Program..: _DCINIT.PRG                           
   Author...: Roger J. Donnay                       
   Notice...: (c) DONNAY Software Designs 1987-2000 
   Date.....: Jun 1, 2000                           
   Notes....: Initialization Routines               
 Ľ
*/

MEMVAR dCCOLOR

STATIC lInitialized := .f.

#include "dccolor.ch"
#include "dcmouse.ch"
#include "xbp.ch"
#INCLUDE "dcdialog.CH"
#INCLUDE "dmlb.CH"
#INCLUDE "foxdbe.CH"
#INCLUDE "cdxdbe.CH"
#INCLUDE "sdfdbe.CH"

#define DC_INITMSG_10  "Invalid directory in SET DCLIP=<directory>: "

*---------------

INIT PROCEDURE _dcinit()

DC_LoadRdds()
DC_Init()
ErrorBlock( {|e|DC_ErrorGUI(e)} )

RETURN

* --------------

FUNCTION DC_Init( lRunTime, cInitCmd )

LOCAL   aDlibs[10], aObjs[10], aMaps[10], nDlibNmbr, nObjNmbr, i,;
        nMapNmbr, aDoPrgName := {}, nCount, cCommand, cCommand2,;
        cKeyLoad, nPointer, nLength, cCharacter, cString, nParam,;
        nCmdParam, lSpeed, nHandle, cDclipEnvir, nFound, cDclipSys,;
        aCommand, GetList := {}, aDot := { {},{},{},{},{} }, ;
        aInterp := {}, lExact := Set(_SET_EXACT,.f.)

IF lInitialized
  RETURN nil
ENDIF

IF Type('dCCOLOR') = 'U'
  DC_ClrArr()
ENDIF

lRuntime := IIF(Valtype(lRuntime)='L',lRuntime,.t.)
cInitCmd := UPPER(IIF(Valtype(cInitCmd)='C',cInitCmd,''))
DC_SetArray(.t.)
lSpeed := .f.
cDclipEnvir := DC_SETDCLIP()
IF DC_CheckPath() .AND. !FILE(cDclipEnvir + 'NUL')
  // "Invalid directory in SET DCLIP=<directory>: "+cDclipEnvir
  DC_WinAlert( DC_INITMSG_10 + cDclipEnvir )
  QUIT
ENDIF

SETCANCEL(.t.)

// Initalize debugging system

_DCDBGPROC("_D_C_BREAK")
_DCDBGTEST(.f.,.t.)
* ALTD(1)

// - Initialize pre-processor array
STORE 0 TO nDlibNmbr, nObjNmbr, nMapNmbr

cDclipSys := 'DCLIP.SYS'
IF '/S' $ cInitCmd
  aCommand := DC_TokenArray(cInitCmd,'/')
  FOR i := 1 TO LEN(aCommand)
    aCommand[i] := '/'+aCommand[i]
  NEXT
  nFound := AScan( aCommand, '/S' )
  IF nFound > 0
    cDclipSys := ALLTRIM(STRTRAN(aCommand[nFound],'/S',''))
  ENDIF
ENDIF

nHandle := DC_TXTOPEN( _D_C_CDNAM(cDclipSys) )
IF nHandle > 0
  STORE 1 TO nCmdParam,nParam
  DO WHILE !DC_TXTEOF(nHandle)
    STORE "" TO cCommand,cCommand2
    cString := ALLTRIM(DC_TXTLINE(nHandle))+CHR(13)
    DC_TXTSKIP(nHandle,1)
    nLength := LEN(cString)
    IF cString="*" .OR. cString='/'
      LOOP
    ENDIF
    IF cString='!'
      AADD( aInterp,STRTRAN(SubStr(cString,2),CHR(13),''))
      LOOP
    ENDIF
    IF !("="$cString) .AND. !("KEY"$cString)
      LOOP
    ENDIF
    IF '//'$cString
      cString := TRIM(SUBSTR(cString,1,AT('//',cString)-1))+CHR(13)
    ENDIF
    FOR nPointer := 1 TO nLength
      cCharacter := SUBSTR(cString,nPointer,1)
      DO CASE
        CASE cCharacter="=" .AND. EMPTY(cCommand2)
          cCommand2 := TRIM(UPPER(cCommand))
          cCommand := ""
        CASE cCharacter=CHR(13) .OR. ( cCharacter="," .AND.;
            ' '+PAD(cCommand2,4)+' '$' COMM PROC BATC #INC SHEL ' )
          IF cCommand2="PROC" .AND. nParam>1 .AND. cCharacter=","
            cCommand += ","
            LOOP
          ENDIF
          DO CASE
            CASE  (cCommand2="COMM" .OR. cCommand2="PROC";
               .OR. cCommand2="BATC".OR. cCommand2="#INC")
              DO CASE
                CASE nParam == 1
                  AADD(aDot[1],ALLTRIM(cCommand))
                  AADD(aDot[2],"")
                  DO CASE
                    CASE cCommand2="COMM"
                      AADD(aDot[3],"C")
                    CASE cCommand2="PROC"
                      AADD(aDot[3],"P")
                    CASE cCommand2="BATC"
                      AADD(aDot[3],"B")
                    CASE cCommand2="#INC"
                      AADD(aDot[3],"I")
                  ENDCASE
                CASE nParam=2
                  aDot[2][LEN(aDot[2])] := cCommand
              ENDCASE
              nParam++
              cCommand := ""
          ENDCASE
          IF cCharacter=CHR(13)
            nParam := 1
            DO CASE
              CASE cCommand2="COMM" .OR. cCommand2="PROC" .OR. ;
                   cCommand2="BATC" .OR. cCommand2="#INC"
                nCmdParam++
              CASE cCommand2="KEYL"
                cKeyLoad := ALLTRIM(cCommand)
              CASE cCommand2="HIST"
                DC_SETT('HISTORY', ALLTRIM(cCommand) )
              CASE cCommand2="EDITOR"
                DC_SETT('EDITOR', ALLTRIM(cCommand) )
              CASE cCommand2="TURB"
                DC_SETT('TURBO', ALLTRIM(cCommand) )
              CASE cCommand2="DEBUGFILE"
                DC_SETT('DEBUGFILE', ALLTRIM(cCommand) )
              CASE cCommand2="LIB" .AND. !(cCommand2='LIBS') .AND. nDlibNmbr<10
                nDlibNmbr++
                aDlibs[nDlibNmbr] := ALLTRIM(cCommand)
              CASE cCommand2=="DO"
                AADD( aDoPrgName,;
                      STRTRAN(SUBSTR(cString,AT('=',cString)+1),CHR(13),'') )
              CASE cCommand2=="INTERP"
                AADD( aInterp,;
                      STRTRAN(SUBSTR(cString,AT('=',cString)+1),CHR(13),'') )
              CASE cCommand2=="OBJ" .AND. nObjNmbr<10
                nObjNmbr++
                aObjs[nObjNmbr] := ALLTRIM(cCommand)
              CASE cCommand2="MAP" .AND. nMapNmbr<10
                nMapNmbr++
                aMaps[nMapNmbr] := ALLTRIM(cCommand)
              CASE !EMPTY(cCommand2) .AND. !EMPTY(cCommand)
                DO CASE
                  CASE VAL(cCommand)>0 .OR. ALLTRIM(cCommand)='0'
                    cCommand := VAL(cCommand)
                  CASE ' '+UPPER(ALLTRIM(cCommand))+' ' $ ' ON OFF '
                    cCommand := IIF( UPPER(ALLTRIM(cCommand))='ON',.t.,.f.)
                ENDCASE
                DC_SETT( cCommand2, cCommand )
            ENDCASE
            cCommand := ""
          ENDIF
        OTHERWISE
          cCommand += cCharacter
          LOOP
      ENDCASE
    NEXT
  ENDDO
  DC_TXTCLOSE( nHandle )
ENDIF
DC_PROCNAME('')
DC_LINENO(0)
DC_SETT('MAXR',DC_MaxRow()+1)

DC_CLRARR()

FOR nCount := 1 TO nMapNmbr
  DC_MAPLOAD(aMaps[nCount])
NEXT
FOR nCount := 1 TO nDlibNmbr
  DC_LIBLOAD(aDlibs[nCount])
NEXT
FOR nCount := 1 TO nObjNmbr
  DC_OBJLOAD(aObjs[nCount],.t.)
NEXT
DC_DOTCONFIG('COMMAND',aDot)
IF !EMPTY(cKeyLoad)
  DC_KEYLOAD(cKeyLoad)
ENDIF
IF !lRunTime
  IF !EMPTY(cInitCmd)
  ELSE
    IF _D_C_CDFIL('AUTOEXEC.DCB')
      KEYBOARD "BATCH AUTOEXEC.DCB" + CHR(13)
    ENDIF
  ENDIF
ENDIF
FOR nCount := 1 TO LEN(aDoPrgName)
  DC_DO(aDoPrgName[nCount])
NEXT

FOR nCount := 1 TO LEN(aInterp)
  DC_INTERPRET(aInterp[nCount])
NEXT
DC_SetArray(.f.)
lInitialized := .t.
Set(_SET_EXACT,lExact)

RETURN .t.

/* --------------------- */

FUNCTION DC_CheckPath ( lPath )

STATIC lCheckPath := .f.

IF Valtype(lPath)='L'
  lCheckPath := lPath
ENDIF
RETURN lCheckPath

* -------------------

FUNCTION DC_LoadRdds()

LOCAL i, aDbeList := DbeList(), cDbeList := '', cDbe := dbeSetDefault(), ;
      bErrorBlock := ErrorBlock({|e|_TrapError(e)})

IF Valtype(aDbeList) = 'A'
  FOR i := 1 TO Len(aDbeList)
    cDbeList += aDbeList[i,1] + ','
  NEXT
ENDIF

aDbeList := cDbeList

  BEGIN SEQUENCE
  IF !('SDFDBE'$aDbeList) .AND. !DbeLoad( "SDFDBE",.F.)
     DC_WinAlert( "Database-Engine SDFDBE not loaded" )
  ENDIF
  DbeBuild( "SDFCDX", "SDFDBE", "CDXDBE" )
  DbeInfo( COMPONENT_DATA , SDFDBE_LOGICAL_TOKEN, "10")
  DbeInfo( COMPONENT_DATA , SDFDBE_DECIMAL_TOKEN, "." )
  END SEQUENCE

  BEGIN SEQUENCE
  IF !('DBFDBE'$aDbeList) .AND. !DbeLoad( "DBFDBE",.T.)
     DC_WinAlert( "Database-Engine DBFDBE not loaded" )
  ENDIF
  END SEQUENCE

  BEGIN SEQUENCE
  IF !('NTXDBE'$aDbeList) .AND. !DbeLoad( "NTXDBE",.T.)
     DC_WinAlert( "Database-Engine NTXDBE not loaded"  )
  ENDIF
  END SEQUENCE

  BEGIN SEQUENCE
  IF !('DBFNTX'$aDbeList) .AND. !DbeBuild( "DBFNTX", "DBFDBE", "NTXDBE" )
     DC_WinAlert( "DBFNTX Database-Engine, Could not build engine" )
  ENDIF
  END SEQUENCE

  BEGIN SEQUENCE
  IF !('CDXDBE'$aDbeList) .AND. !DbeLoad( "CDXDBE",.T.)
     DC_WinAlert( "Database-Engine CDXDBE not loaded" )
  ENDIF
  END SEQUENCE

  BEGIN SEQUENCE
  IF !('DBFCDX'$aDbeList) .AND. !DbeBuild( "DBFCDX", "DBFDBE", "CDXDBE" )
     DC_WinAlert( "DBFCDX Database-Engine, Could not build engine" )
  ENDIF
  END SEQUENCE

  BEGIN SEQUENCE
  IF !('FOXDBE'$aDbeList) .AND. !DbeLoad( "FOXDBE",.T.)
     DC_WinAlert( "Database-Engine FOXDBE not loaded" )
  ENDIF
  END SEQUENCE

  BEGIN SEQUENCE
  IF !('FOXCDX'$aDbeList) .AND. !DbeBuild( "FOXCDX", "FOXDBE", "CDXDBE" )
     DC_WinAlert( "FOXCDX Database-Engine, Could not build engine" )
  ENDIF
  DbeSetDefault('FOXCDX')
  DbeInfo( COMPONENT_DATA, FOXDBE_CREATE_2X, .F. )
  DbeInfo( COMPONENT_DATA, FOXDBE_LOCKMODE , FOXDFBE_LOCKMODE_VISUAL )
  /*
  DbeInfo( COMPONENT_DATA, FOXDBE_CREATE_2X, .T. )
  DbeInfo( COMPONENT_DATA, FOXDBE_LOCKMODE , FOXDBE_LOCKMODE_2X )
  DbeInfo( COMPONENT_ORDER, CDXDBE_MODE , CDXDBE_FOXPRO2X )
  */

  END SEQUENCE

  BEGIN SEQUENCE
  IF !('DELDBE'$aDbeList) .AND. !DbeLoad( "DELDBE",.F.)
     DC_WinAlert( "Database-Engine DELDBE not loaded" )
  ENDIF
  END SEQUENCE

DbeSetDefault(cDbe)

ErrorBlock(bErrorBlock)

RETURN .t.

* ----------------

STATIC FUNCTION _TrapError()

BREAK

RETURN nil

