/*
 ķ
   Program..: _DCRDD.PRG                                           
   Author...: Roger J. Donnay                                      
   Notice...: (c) DONNAY Software Designs 1987-2000                
   Date.....: May  21, 2000                                        
   Notes....: Front end to Third-party RDD's                       
                                                                   
   Functions:  dc_setrdd(), dc_isrdd(), dc_isdbfsix(),             
               dc_rddinfo(), dc_dbfrdd(), dc_isscoperdd()          
               dc_superrdd(), dc_foxrdd()                          
 Ľ
*/

#include 'dcdialog.ch'
#include 'inkey.ch'
#include 'dmlb.ch'

#define DC_RDDMSG_1 'Invalid RDD selection - '+cSuperRdd
#define DC_RDDMSG_2  'DBE Name      Description'
#define DC_RDDMSG_3  'Select a Database Driver'

#define ADSDBE_MEMOFILE_EXT    (DBE_USER+1) // RO
#define ADSDBE_INDEX_EXT       (DBE_USER+2) // RW
#define ADSDBE_TBL_MODE        (DBE_USER+3) // RW
#define ADSDBE_LOCK_MODE       (DBE_USER+4) // RW
#define ADSDBE_RIGHTS_MODE     (DBE_USER+5) // RW
#define ADSDBE_MEMOBLOCKSIZE   (DBE_USER+6) // RW
#define ADSDBE_PASSWORD        (DBE_USER+7) // RW

// Return types of ADSDBE_TBL_MODE
#define ADSDBE_NTX 1
#define ADSDBE_CDX 2
#define ADSDBE_ADT 3


// ------------------------- //

FUNCTION dc_setrdd ( cRdd )
LOCAL aRddInfo, cRddName

IF !EMPTY(ALIAS())
  cRddName := V_RDDNAME()
  IF !EMPTY(cRddName)
    RETURN UPPER(cRddName)
  ENDIF
ENDIF
IF VALTYPE( cRdd ) = 'C'
  cRddName := DBESetDefault( cRdd )
ELSEIF !EMPTY(ALIAS())
  cRddName := DbInfo( DBO_DBENAME )
ELSE
  cRddName := DbeSetDefault()
ENDIF
RETURN cRddName

// ------------------------- //

FUNCTION dc_superrdd ( cSuperRdd )

IF !EMPTY(cSuperRdd)
  IF cSuperRdd = 'FOXRDD'
    cSuperRdd := DC_FoxRdd()
  ENDIF
  IF !DC_ISRDD(cSuperRdd)
    DC_WinAlert(DC_RDDMSG_1)
  ELSE
    RETURN V_SUPERRDD( cSuperRdd )
  ENDIF
ELSEIF DC_SETRDD()='FLEXFILE'
  RETURN V_SUPERRDD()
ELSEIF ' '+DC_SetRdd()+' ' $ ' DBFMEMO DBFBLOB '
  RETURN DC_DO('MemoSetSuper()')
ENDIF
RETURN DC_SetRdd()

* ------------------

FUNCTION dc_rddinfo ( cRdd )

LOCAL aRddInfo := ARRAY(6), cBaseRdd, cOldRdd := DbeSetDefault(), xInfo

cRdd := IIF(VALTYPE(cRdd)='C',UPPER(ALLTRIM(cRdd)),DC_SETRDD())

cBaseRdd := ''
IF cRdd = 'FLEXFILE'
  cRdd := V_SUPERRDD()
  cBaseRdd := 'FLEXFILE'
ELSEIF cRdd = 'DBFMEMO'
  cRdd := DC_DO('MemoSetSuper()')
  cBaseRdd := 'DBFMEMO'
ELSEIF cRdd = 'DBFBLOB'
  cRdd := DC_DO('MemoSetSuper()')
  cBaseRdd := 'DBFBLOB'
ENDIF
cRdd := ' '+cRdd+' '
aRddInfo[1] := ALLTRIM(cRdd)
aRddInfo[2] := .t.
aRddInfo[3] := ''

DO CASE
    CASE cRdd $ ;
    ' DBFNTX DBFNDX DBFMDX DBFCDX DBFCMX ' + ;
    'FXDBF DBF DBFCDXAX DBFNTXAX COMIX FORTRESS FOXCDX '
      aRddInfo[3] := '.DBF'
    CASE cRdd $ ' PDX DBPX '
      aRddInfo[3] := '.DB'
    CASE cRdd == ' ADSDBE '
      IF DbeInfo( COMPONENT_DATA, ADSDBE_TBL_MODE ) == ADSDBE_CDX
        aRddInfo[3] := '.DBF'
      ELSEIF DbeInfo( COMPONENT_DATA, ADSDBE_TBL_MODE ) == ADSDBE_ADT
        aRddInfo[3] := '.ADT'
      ENDIF
ENDCASE
aRddInfo[4] := ''
DO CASE
    CASE cRdd $ ' PDX DBPX '
      aRddInfo[4] := '.PX'
    CASE cRdd $ ' DBFNTX DBFNTXAX '
      aRddInfo[4] := '.NTX'
    CASE cRdd $ ' DBFNDX '
      aRddInfo[4] := '.NDX'
    CASE cRdd $ ' DBFMDX '
      aRddInfo[4] := '.MDX'
    CASE cRdd $ ' DBFSIX DBFCDX DBFCDXAX '
      aRddInfo[4] := '.IDX'
    CASE cRdd $ ' DBFCMX '
      aRddInfo[4] := '.PCB'
    CASE cRdd == ' ADSDBE '
     DbeSetDefault('ADSDBE')
      IF DbeInfo( COMPONENT_DATA, ADSDBE_TBL_MODE ) == ADSDBE_CDX
        aRddInfo[4] := '.IDX'
      ELSEIF DbeInfo( COMPONENT_DATA, ADSDBE_TBL_MODE ) == ADSDBE_ADT
        aRddInfo[6] := '.ADI'
      ELSE
        aRddInfo[4] := '.NTX'
      ENDIF
      DbeSetDefault(cOldRdd)
    CASE cRdd $ ' COMIX FORTRESS FOXCDX '
      aRddInfo[4] := '.IDX'
ENDCASE
aRddInfo[5] := ''
DO CASE
    CASE cRdd $ ' PDX DBPX '
      aRddInfo[5] := '.PX'
    CASE cRdd $ ' DBFMDX '
      aRddInfo[5] := '.MDX'
    CASE cRdd $ ' DBFSIX DBFCDX FOXCDX DBFCDXAX '
      aRddInfo[5] := '.CDX'
    CASE cRdd $ ' DBFCMX '
      aRddInfo[5] := '.CMX'
    CASE cRdd $ ' COMIX FORTRESS '
      aRddInfo[5] := OrdBagExt()
    CASE cRdd == ' ADSDBE '
      DbeSetDefault('ADSDBE')
      IF DbeInfo( COMPONENT_DATA, ADSDBE_TBL_MODE ) == ADSDBE_CDX
        aRddInfo[5] := '.CDX'
      ELSEIF DbeInfo( COMPONENT_DATA, ADSDBE_TBL_MODE ) == ADSDBE_ADT
        aRddInfo[5] := '.ADI'
      ENDIF
      DbeSetDefault(cOldRdd)
ENDCASE
aRddInfo[6] := ''
DO CASE
    CASE cBaseRdd = 'FLEXFILE'
      aRddInfo[6] := V_SETEXT()
    CASE cBaseRdd = 'DBFMEMO'
      aRddInfo[6] := '.DBV'
    CASE cRdd $ ' DBFNTX DBFNTXAX DBFCDX DBFNDX DBFMDX DBFCMX DBF '
      aRddInfo[6] := '.DBT'
    CASE cRdd $ ' FOXCDX FXDBF DBFCDXAX '
      aRddInfo[6] := '.FPT'
    CASE cRdd $ ' ADSDBE '
      xInfo := DC_DbeInfo( COMPONENT_DATA, DBE_USER + 1 )
      IF Valtype(xInfo) # 'C'
        xInfo := '.FPT'
      ENDIF
      aRddInfo[6] := '.' + xInfo
ENDCASE
RETURN aRddInfo

// ------------------------- //

FUNCTION dc_isrdd ( cRdd )

STATIC cRdds := {}
LOCAL cOldRdd, lRddIsValid, nRdd, aDbeList
cRdd := IIF(VALTYPE(cRdd)='C',UPPER(ALLTRIM(cRdd)),'')
IF EMPTY(cRdd)
  RETURN .f.
ENDIF
aDbeList := DC_AConvert(DbeList())
nRdd := ASCAN(aDbeList[1],{|x|x==cRdd} )
IF nRdd = 0
  RETURN .f.
ENDIF
RETURN .t.

// ------------------------- //

FUNCTION dc_isdbfsix ( nArea )
LOCAL nSaveArea, lSixRdd
nSaveArea := SELE()
nArea := IIF(VALTYPE(nArea)='N',nArea,nSaveArea)
SELECT (nArea)
lSixRdd := ' '+DC_SUPERRDD()+' ' $ ' DBFSIX SIXCDX SIXNSX DBFNSX DBFCDXAX '
SELECT (nSaveArea)
RETURN lSixRdd

// ------------------------- //

FUNCTION dc_dbfrdd
LOCAL i
LOCAL aRdds := ;
  {'DBFNTX',;
   'DBFNDX',;
   'COMIX',;
   'FORTRESS',;
   'DBFCDX',;
   'FOXCDX',;
   'ADSDBE',;
   'DBFCDXAX',;
   'DBFNTXAX',;
   'DBFMDX' }
FOR i := 1 TO LEN(aRdds)
  IF DC_ISRDD(aRdds[i])
    RETURN aRdds[i]
  ENDIF
NEXT
RETURN ''

// ------------------------- //

FUNCTION dc_isscoperdd

RETURN ' '+DC_SUPERRDD()+' ' $ ' DBFNTX DBFCDX FOXCDX ADSDBE COMIX ';
          .AND. !EMPTY(ALIAS()) .AND. !EMPTY(INDEXKEY(0))

// ------------------------- //

FUNCTION dc_dictrdd ( cRdd )

STATIC cDictRdd := ''

cDictRdd := IIF(Valtype(cRdd)='C',cRdd,cDictRdd)
IF EMPTY(cDictRdd)
  cDictRdd := DC_DbfRdd()
ENDIF
RETURN cDictRdd

/* --------------------------- */

FUNCTION DC_DataConvert ( cFileName, cFromRdd, cToRdd, cExtension )

LOCAL aDirectory, GetList := {}, cScrn, cOldPath, i, lOk

cFileName := Pad(Upper(IIF(Valtype(cFileName)='C',cFileName,'')),100)
cFromRdd := Pad(Upper(IIF(Valtype(cFromRdd)='C',cFromRdd,'')),10)
cToRdd := Pad(Upper(IIF(Valtype(cToRdd)='C',cToRdd,'')),10)
cExtension := Pad(Upper(IIF(Valtype(cExtension)='C',cExtension,'')),4)
IF Empty(cExtension)
  cExtension := DC_DbtExt()
ENDIF
IF Empty(cFromRdd)
  cFromRdd := Pad(DC_SetRdd(),10)
ENDIF
IF Empty(cToRdd)
  cToRdd := Pad(DC_FoxRdd(),10)
ENDIF
cOldPath := DC_CurPath()
DC_ChDir(Set(_SET_DEFAULT))
IF Empty(cFileName)
  @ 1,1 DCSAY 'File Name.  Enter "ALL" for All files'
  @ 2,1 DCGET cFileName PICTURE '@K@!' GETSIZE 50 ;
    VALID {||DC_ReadEmpty(cFileName)} ;
    POPUP {|c|DC_PopFile( c,,'*.DBT')}
  @ 4,1 DCSAY 'FROM DBE' GET cFromRdd POPUP {|c|DC_RddSel()} ;
        SAYSIZE 10 SAYRIGHTBOTTOM
  @ 5,1 DCSAY 'TO DBE' GET cToRdd POPUP {|c|DC_RddSel()} ;
        SAYSIZE 10 SAYRIGHTBOTTOM
  @ 6,1 DCSAY 'Extension' GET cExtension ;
        SAYSIZE 10 SAYRIGHTBOTTOM
  DCREAD GUI EXPRESS FIT ADDBUTTONS TO lOk MODAL ENTEREXIT ;
    TITLE 'Convert Database(s)'
ENDIF
IF !lOk .OR. Empty(cFileName)
  RETURN .f.
ENDIF
cFileName := AllTrim(cFileName)
IF cFileName=='ALL' .OR. cFileName == '"ALL"'
  aDirectory := Directory('*'+cExtension)
ELSE
  aDirectory := {{cFileName}}
ENDIF
dbCloseAll()
DO CASE
  CASE !Empty(cToRdd)
  CASE DC_ISRDD( 'COMIX' )
    cToRdd := 'COMIX'
  CASE DC_ISRDD( 'FORTRESS' )
    cToRdd := 'FORTRESS'
  CASE DC_ISRDD( 'DBFCDXAX' )
    cToRdd := 'DBFCDXAX'
  CASE DC_ISRDD( 'DBFCDX')
    cToRdd := 'DBFCDX'
  CASE DC_ISRDD( 'FOXCDX')
    cToRdd := 'FOXCDX'
  OTHERWISE
    DC_WinAlert('Sorry!  No .FPT compatible DBE is available.')
    RETURN .f.
ENDCASE
FOR i := 1 TO LEN(aDirectory)
  cFileName := Strtran(aDirectory[i,1],cExtension,'')
  DC_UseArea(.f.,cFromRdd,cFileName)
  cScrn := DC_WaitOn( 'Converting ' + cFileName + '.DBF/.DBT',,,,20,30 )
  _dbExport('DCTMPFPT',{},,DC_OdBlock(,,,,'Copied',,.f.,,.f.),,,.f., ;
             Alltrim(cToRdd) )
  DC_Impl(cScrn)
  dbCloseAll()
  FRename(cFileName+'.DBT',cFileName+'.DTK')
  FRename(cFileName+'.DBF',cFileName+'.DBK')
  FRename('DCTMPFPT.DBF',cFileName+'.DBF')
  FRename('DCTMPFPT.FPT',cFileName+'.FPT')
NEXT
DC_ChDir(cOldPath)
RETURN .t.

/* ---------------------- */

FUNCTION dc_foxrdd ()

LOCAL cRdd := DC_SetRdd()

DO CASE
    CASE ' ' + cRdd + ' ' $ ' FOXCDX COMIX FORTRESS DBFCDXAX DBFCDX ADSDBE '
    CASE DC_ISRDD( 'ADSDBE' )
      cRdd := 'ADSDBE'
    CASE DC_ISRDD( 'FORTRESS' )
      cRdd := 'FORTRESS'
    CASE DC_ISRDD( 'COMIX' )
      cRdd := 'COMIX'
    CASE DC_ISRDD( 'FOXCDX' )
      cRdd := 'FOXCDX'
    OTHERWISE
      cRdd := 'DBFCDX'
ENDCASE
RETURN cRdd

// ------------------------- //

FUNCTION dc_rddsel ( cRdd, lSet )

LOCAL aRdds := {}, aRddList := {}, aRddChoice := {}, i, cOldRdd := DbeSetDefault(), ;
      nChoice, lExact := SET(_SET_EXACT), lGui := DC_Gui(.t.)

cRdd := IIF(VALTYPE(cRdd)='C',TRIM(UPPER(cRdd)),'')
lSet := IIF(VALTYPE(lSet)='L',lSet,.f.)
IF lSet .AND. !EMPTY(cRdd) .AND. DC_IsRdd(cRdd)
  dbeSetDefault(cRdd)
  RETURN cRdd
ENDIF
aRdds := { ;
  { 'DBFNTX','.DBF/.DBT/.NTX Standard Driver (Alaska)' },;
  { 'DBFNDX','.DBF/.DBT/.NDX Driver (Alaska)' },;
  { 'DBFCDX','.DBF/.CDX/.IDX/.DBT Driver (Alaska)' },;
  { 'DBFDBE','.DBF Database Engine (Alaska)' },;
  { 'CDXDBE','.CDX Index Engine (Alaska)' },;
  { 'NTXDBE','.NTX Index Engine (Alaska)' },;
  { 'DBF',   '.DBF/.DBT Driver (Alaska)' },;
  { 'DBPX',  '.DB/.PX/.IX Paradox Driver (Alaska)' },;
  { 'DBFMDX','.DBF/.DBT/.MDX/.NDX Driver (Alaska)'},;
  { 'DBFIV', '.DBF/.DBT (dBASE-IV) Driver (Alaska)'},;
  { 'DBFMEMO','.DBV memo - (Alaska)' },;
  { 'DBFBLOB','.DBV (Vari-length fields) - (Alaska)' },;
  { 'DELDBE', 'Text File (delimited) (Alaska)' },;
  { 'SDFDBE', 'Standard Data Format Text File (Alaska)' },;
  { 'SDFCDX', 'Standard Data Format Text File with CDX Index (Alaska)' },;
  { 'COMIX', '.DBF/.DBT/.FPT/.CDX Driver (LoadStone)'},;
  { 'FORTRESS', '.DBF/.DBT/.FPT/.CDX Driver, Client/Server'},;
  { 'RQBRDD','Btrieve Driver (RaSQL/B - Pinnacle)'},;
  { 'RQXRDD','Netware SQL Driver (RaSQL/X - Pinnacle)'},;
  { 'FLEXFILE','.DBV memo (Vari-length fields) - (Ganahl)' },;
  { 'DBFNTXAX','.DBF/.NTX/.DBT (Advantage Server)'},;
  { 'DBFCDXAX','.DBF/.CDX/.FPT (Advantage Server)'},;
  { 'FOXDBE','.DBF/.FPT (FOX Database Engine - Alaska)'},;
  { 'FOXCDX','.DBF/.CDX/.FPT (Visual FoxPro Database Engine - Alaska)'},;
  { 'FOXCDX2X','.DBF/.CDX/.FPT (FoxPro Database Engine (2.X) - Alaska)'},;
  { 'ODBCDBE','ODBC Driver - Alaska'},;
  { 'WIN400','DB2 (AS/400) Driver (BEST)'} ;
 }

IF 'ADSDBE' $ DbeList()
  DbeSetDefault('ADSDBE')
  IF DbeInfo( COMPONENT_DATA, ADSDBE_TBL_MODE ) == ADSDBE_CDX
    AAdd( aRdds, { 'ADSDBE','.DBF/.CDX/.IDX/.FPT (Advantage Server)'} )
  ELSE
    AAdd( aRdds, { 'ADSDBE','.DBF/.NTX/.DBT (Advantage Server)'} )
  ENDIF
  DbeSetDefault(cOldRdd)
ENDIF

aRdds := DC_AConvert(aRdds)

aRddList := DC_Aconvert(DbeList())
SET(_SET_EXACT,.t.)
FOR i := 1 TO LEN(aRddList[1])
  IF aRddList[2,i]
     LOOP
  ENDIF
  nChoice := ASCAN( aRdds[1], aRddList[1,i] )
  IF nChoice > 0
    AADD( aRddChoice, PAD(aRddList[1,i],10)+' - '+aRdds[2,nChoice])
  ELSE
    AADD( aRddChoice, PAD(aRddList[1,i],10)+' - Unknown' )
  ENDIF
NEXT
nChoice := IIF(Empty(cRdd),0,ASCAN( aRddList[1], cRdd ))
SET(_SET_EXACT,lExact)
IF nChoice = 0

  nChoice := DC_APick( , , 80, 11, aRddChoice, ;
                    DC_RDDMSG_2, nil, DC_RDDMSG_3, nil, nil, ;
                    nil, nil, nil, nil, nil, nil )

  IF nChoice > 0
    cRdd := DC_Token(aRddChoice[nChoice],' -',1)
    IF lSet
      DbeSetDefault( cRdd )
    ENDIF
  ELSE
    cRdd := ''
  ENDIF
ENDIF
DC_Gui(lGui)
RETURN cRdd

* ------------------

FUNCTION DC_DbeLoad( cDbe, lHidden )

IF AScan( dbeList(), {|a|Upper(a[1])==Upper(cDbe)}) == 0
  RETURN DbeLoad( cDbe, lHidden )
ENDIF

RETURN .t.

* ------------------

FUNCTION DC_DbeBuild( cCompoundDBE, cDataDBE, cOrderDBE, cRelationDBE, cDictionaryDBE )

IF AScan( dbeList(), {|a|Upper(a[1])==Upper(cCompoundDbe)}) == 0
  RETURN DbeBuild( cCompoundDBE, cDataDBE, cOrderDBE, cRelationDBE, cDictionaryDBE )
ENDIF

RETURN .t.



