/*
 ķ
   Program..: XDOT.PRG                              
   Author...: Roger J. Donnay                       
   Notice...: (c) DONNAY Software Designs 1987-2001 
   Date.....: Aug 29, 2002                          
   Notes....: XDOT.EXE main startup program         
 Ľ
*/

#include 'std.ch'
#include 'inkey.ch'
#include 'set.ch'
#include 'dcbitmap.ch'
#include 'xbp.ch'
#INCLUDE "dcdialog.CH"
#include "dcicon.ch"
#include "appevent.ch"
#include "dchelp.ch"
#include "dbfdbe.ch"
#INCLUDE "dmlb.CH"
#INCLUDE "foxdbe.CH"
#INCLUDE "cdxdbe.CH"
#INCLUDE "sdfdbe.CH"

#define ADSDBE_MEMOFILE_EXT       (DBE_USER+1) // RO
#define ADSDBE_INDEX_EXT          (DBE_USER+2) // RW
#define ADSDBE_TBL_MODE           (DBE_USER+3) // RW
#define ADSDBE_LOCK_MODE          (DBE_USER+4) // RW
#define ADSDBE_RIGHTS_MODE        (DBE_USER+5) // RW
#define ADSDBE_MEMOBLOCKSIZE      (DBE_USER+6) // RW
#define ADSDBE_PASSWORD           (DBE_USER+7) // RW
#define ADSDBE_FREETABLE          (DBE_USER+8)  // RW
#define ADSDBE_TABLENAME_IS_ALIAS (DBE_USER+9)  // RW
#define ADSDBE_DELETEOBJECT       (DBE_USER+10) // RW

// Return types of ADSDBE_TBL_MODE
//
#define ADSDBE_NTX 1
#define ADSDBE_CDX 2
#define ADSDBE_ADT 3

// Return types of ADSDBE_LOCK_MODE
//
#define ADSDBE_COMPATIBLE_LOCKING  0
#define ADSDBE_PROPRIETARY_LOCKING 1

#pragma Library("ADAC20B.LIB")

#if XPPVER > 1900000
#pragma Library("ascom10")
EXTERNAL CreateObject
#endif

#ifdef TOOLS
  #pragma Library("XbtBase1.Lib")
  #pragma Library("XbtBase2.Lib")
  EXTERNAL DirMake
#endif

#ifdef HRF
  #pragma Library("hrfclass.Lib")
  EXTERNAL HTMLDocument
#endif

EXTERNAL AX_SetScope, _Quit, _CopyFile, _TypeFile, DC_DbExport

#if XPPVER > 02000000
  EXTERNAL TimeToSec, Center, DC_Xml2ObjectTree
#endif
#ifdef EXPRESS19
EXTERNAL AutomationTranslateColor // DC_DbImport
#endif

/*
EXTERNAL DC_Xml2ObjectTree
#pragma Library("dcxml.lib")
*/

FUNCTION Main

LOCAL i, oAppFocus := SetAppFocus(), oAdsSession, cSession, cServer, ;
      lAdsDbeNtx := .f., lAdsDbeCdx := .f., cParam, nHandle, lODBC := .f., ;
      oODBCSession, cUID := '', cPWD := '', cDSN := '', cDBQ := '', ;
      lAdsLocking := .f., cCommand, lAdsDbeAdt := .f., aAdsSession, ;
      aServer[0], cVar, cAdsServer, lFox2X := .f.

cServer := CurDrive() + ':'
FOR i := 1 TO PCount()
  cParam := PValue(i)
  IF !Empty(cParam)
    IF '/AN' $ Upper(cParam) .OR. '/A' == Upper(cParam) .OR. Upper(cParam) == '/ADSNTX'
      lAdsDbeNtx := .t.
    ELSEIF '/AC' $ Upper(cParam) .OR. Upper(cParam) == '/ADSCDX' .OR. DC_DictRdd() = 'ADSDBE'
      lAdsDbeCdx := .t.
    ELSEIF '/AA' $ Upper(cParam) .OR. Upper(cParam) == '/ADSADT'
      lAdsDbeAdt := .t.
    ELSEIF '/AL' $ Upper(cParam) .OR. Upper(cParam) == '/ADSLOCK'
      lAdsLocking := .t.
    ELSEIF '/FOX2X' $ Upper(cParam)
      lFox2X := .t.
    ELSEIF Upper(cParam) = '/ADSSERVER:'
      cAdsServer := Substr(cParam,12)
    ELSEIF Upper(cParam) = '/SRV:'
      cServer := Substr(cParam,6)
      AAdd(aServer,{cServer,nil})
    ELSEIF '/?' $ cParam .OR. '/H' $ Upper(cParam)
      DC_MsgBox({'Command line Options:', ;
                 '', ;
                 '/c:<command line> - Run a sequence of commands', ;
                 '/cset:<command set CH file> - Load custom command set (no DCSTD.CH)', ;
                 '/native - Load Native command set (DCNATIVE.CH)', ;
                 '/fox2x - FOXCDX driver creates 2.x compatible files', ;
                 '/adsntx - Load ADSDBE driver (.NTX/.DBT support)', ;
                 '/adscdx or /ac- Load ADSDBE driver (.CDX/.IDX/.FPT support)', ;
                 '/adsadt or /aa- Load ADSDBE driver (.ADT support)', ;
                 '/adslock or /al - Use ADS Proprietary Locking', ;
                 '/adsserver:<ADSDBE server>', ;
                 '/odbc - Load ODBC driver', ;
                 '/dsn:<data source name> - ODBC (use a + for each space in name)', ;
                 '/uid:<user id> - ODBC / ADSDBE', ;
                 '/pwd:<password> - ODBC / ADSDBE', ;
                 '/dbq:<database name> - ODBC', ;
                 '/defa:<default database directory>', ;
                 '/dbe:<database engine name>', ;
                 '/use:<database name>', ;
                 '/ind:<index name>', ;
                 '/dll:<dllname> - Load a dynamic link library', ;
                 '/srv:<server name, drive letter or data dictionary> - ADSDBE', ;
                 '/obj:<objfilename> - Load an .OBJ file', ;
                 '/proc:<procedure> - Run a procedure ( with parameters)', ;
                 '', ;
                 'ex 1: XDOT /c:USE customer INDEX customer;BROWSE', ;
                 'ex 2: XDOT /odbc /dsn:dBASE+Files adsntx /obj:TEST.OBJ /proc:MyMenu()', ;
                 'ex 3: XDOT /ac /al /adsserver:xmas.add;UID:santa;pwd:rudolf', ;
                 'ex 4: XDOT /dbe:FOXCDX /use:customer /ind:customer'}, ;
                 ,,,,,,,,,,,'8.Courier')

    ELSEIF Upper(cParam) = '/DLL:'
      DC_DllLoad( Substr(cParam,6))
    ELSEIF Upper(cParam) = '/OBJ:'
      DC_ObjLoad( Substr(cParam,6))
    ELSEIF Upper(cParam) = '/ODBC'
      lODBC := .t.
    ELSEIF Upper(cParam) = '/DSN:'
      cDSN := Strtran(Substr(cParam,6),'+',' ')
    ELSEIF Upper(cParam) = '/CSET:'
      DC_PreCh(Upper(Substr(cParam,7)))
    ELSEIF Upper(cParam) = '/NATIVE'
      DC_PreCh('DCNATIVE.CH')
    ELSEIF Upper(cParam) = '/UID:'
      cUID := Substr(cParam,6)
    ELSEIF Upper(cParam) = '/DBQ:'
      cDBQ := Substr(cParam,6)
    ELSEIF Upper(cParam) = '/PWD:'
      cPWD := Substr(cParam,6)
    ELSEIF Upper(cParam) = '/PROC:'
      &(Substr(cParam,7))
    ELSEIF Upper(cParam) = '/DEFA:'
      Set(_SET_DEFAULT,Substr(cParam,7))
      DC_Sett('PROMPT','DEFA')
    ELSEIF Upper(cParam) = '/DBE:'
      dbeSetDefault(Substr(cParam,6))
    ELSEIF Upper(cParam) = '/USE:'
      USE (Substr(cParam,6))
    ELSEIF Upper(cParam) = '/IND:'
      SET INDEX TO (Substr(cParam,6))
    ELSEIF Upper(cParam) = '/C:'
      cCommand := Substr(cParam,4)
    ELSEIF cParam = '/'
      DC_WinAlert('Unknown command line parameter: ' + cParam)
    ENDIF
  ENDIF
NEXT

SetKey(K_ALT_C,{||dc_quit()})

SET COLLATION TO AMERICAN

DC_DictClose(.f.)
DC_ExplMode(.f.)

DC_ScopeExpress(.t.)

IF lAdsDbeNtx .OR. lAdsDbeCdx .OR. lAdsDbeAdt

  IF Empty(cAdsServer)
    AAdd( aServer, { CurDrive() + ':', nil } )
  ENDIF

  BEGIN SEQUENCE

  IF ! DbeLoad( "ADSDBE" )
    DC_WinAlert( "Unable to load ADSDBE", "ADS Server",, ;
                  XBPMB_WARNING + XBPMB_APPMODAL )
    BREAK
  ENDIF

  dbeSetDefault('ADSDBE')
  IF lAdsDbeCdx
    #if XPPVER > 1900000
    Set(_SET_NULLVALUE,.f.)
    #endif
    DbeInfo( COMPONENT_DATA, ADSDBE_TBL_MODE, ADSDBE_CDX )
    DbeInfo( COMPONENT_ORDER, ADSDBE_TBL_MODE, ADSDBE_CDX )
    DC_AdsIndexModeDefault( ADSDBE_CDX )
  ELSEIF lAdsDbeNtx
    DbeInfo( COMPONENT_DATA, ADSDBE_TBL_MODE, ADSDBE_NTX )
    DbeInfo( COMPONENT_ORDER, ADSDBE_TBL_MODE, ADSDBE_NTX )
    DC_AdsIndexModeDefault( ADSDBE_NTX )
  ELSEIF lAdsDbeAdt
    #if XPPVER > 1900000
    Set(_SET_NULLVALUE,.f.)
    #endif
    DbeInfo( COMPONENT_DATA, ADSDBE_TBL_MODE, ADSDBE_ADT )
    DbeInfo( COMPONENT_ORDER, ADSDBE_TBL_MODE, ADSDBE_ADT )
    DC_AdsIndexModeDefault( ADSDBE_ADT )
  ENDIF
  IF lAdsLocking
    DbeInfo( COMPONENT_DATA, ADSDBE_LOCK_MODE, ADSDBE_PROPRIETARY_LOCKING  )
    DC_AdsLockModeDefault( ADSDBE_PROPRIETARY_LOCKING )
  ELSE
    DbeInfo( COMPONENT_DATA, ADSDBE_LOCK_MODE, ADSDBE_COMPATIBLE_LOCKING  )
    DC_AdsLockModeDefault( ADSDBE_COMPATIBLE_LOCKING )
  ENDIF

  DbeInfo( COMPONENT_DATA, ADSDBE_TABLENAME_IS_ALIAS, .T. )

  END SEQUENCE

  FOR i := 1 TO Len(aServer)

    cServer := aServer[i,1]
    IF !Empty(cUID)
      cServer += ";UID=" + cUID
    ENDIF
    IF !Empty(cPWD)
      cServer += ";PWD=" + cPWD
    ENDIF
    oAdsSession := DC_AdsSession( cServer, i )
    cVar := 'SRV' + Alltrim(Str(i))
    PUBLIC &cVar := oAdsSession

  NEXT

  IF !Empty(cAdsServer)
    oAdsSession := DC_AdsSession( cAdsServer )
    oAdsSession:setDefault()
  ENDIF

ENDIF

IF lODBC

  BEGIN SEQUENCE

  IF ! DbeLoad( "ODBCDBE" )
    DC_WinAlert( "Unable to load ODBCDBE", "ODBC Driver",, ;
                  XBPMB_WARNING + XBPMB_APPMODAL )

    BREAK
  ENDIF

  cSession := "DBE=ODBCDBE"
  IF !Empty(cDSN)
    cSession += ";DSN=" + cDSN
  ENDIF
  IF !Empty(cUID)
    cSession += ";UID=" + cUID
  ENDIF
  IF !Empty(cPWD)
    cSession += ";PWD=" + cPWD
  ENDIF
  IF !Empty(cDBQ)
    cSession += ";DBQ=" + cDBQ
  ENDIF

  oODBCSession := &('DacSession():new( "' + cSession + '")')

  IF !oODBCSession:isConnected()
    DC_WinAlert( "Unable to establish connection to ODBC Server" + Chr(13) + ;
                 "Error Code: " + Alltrim(Str(oODBCSession:getLastError())) + Chr(13) + ;
                 oODBCSession:getLastMessage() + ';' + cSession )
  ENDIF

  END SEQUENCE

ENDIF

FErase('XPPLOAD.TXT')

DC_Gui(.f.)
DC_DotLogo(.t.)

/* -- Initialize system -- */
DC_INIT()

IF lFox2x .AND. !'FOXCDX2X' $ DbeList()
  DbeUnload('FOXCDX')
  BEGIN SEQUENCE
  IF !DbeBuild( "FOXCDX2X", "FOXDBE", "CDXDBE" )
    DC_WinAlert( "FOXCDX2X Database-Engine, Could not build engine" )
  ENDIF
  DbeSetDefault('FOXCDX2X')
  DbeInfo( COMPONENT_DATA, FOXDBE_CREATE_2X, .T. )
  DbeInfo( COMPONENT_DATA, FOXDBE_LOCKMODE , FOXDBE_LOCKMODE_2X )
  DbeInfo( COMPONENT_ORDER, CDXDBE_MODE , CDXDBE_FOXPRO2X )
  dbeSetDefault('FOXCDX2X')
  END SEQUENCE
ENDIF

DllLoad('DCLIP2.DLL')

DC_AutoRestoreWindow({HKEY_LOCAL_MACHINE,'Software\Donnay Software\Samples\Windows'})
DC_GroupBoxFix(.t.)

DC_IconDefault(ICON_EXPRESS)

LoadHelpOptions()
DC_Dot(,,cCommand,'eXpress++ Dot-Prompt and Interpreter')

SetAppFocus(oAppFocus)

FOR i := 1 TO Len(aServer)
  oAdsSession := aServer[i,2]
  IF Valtype(oAdsSession) == 'O' .AND. oAdsSession:isConnected()
    oAdsSession:disconnect()
  ENDIF
NEXT

IF Valtype(oODBCSession) = 'O'
  oODBCSession:disconnect()
ENDIF

RETURN nil

* ----------------

PROC AppSys()

RETURN

* ---------------

PROC DbeSys()

DC_LoadRdds()

RETURN

* -----------------

STATIC FUNCTION LoadHelpOptions( oDialog )

LOCAL cDataPath, cScriptPath, cHtmlPath, cTempPath, ;
      aHelpOptions, oThread

IF !IsFunction('DC_HelpOptions')
  RETURN nil
ENDIF

aHelpOptions := &('DC_HelpOptions()')

cDataPath := DC_Path(AppName(.t.)) + '..\DATA\'
cScriptPath := DC_Path(AppName(.t.)) + '..\SCRIPTS\'
cHtmlPath := DC_Path(AppName(.t.)) + '..\HTML\'
cTempPath := DC_Path(AppName(.t.)) + '..\HTML\'

cDataPath := _CheckPath(cDataPath)
cScriptPath := _CheckPath(cScriptPath)
cHtmlPath := _CheckPath(cHtmlPath)
cTempPath := _CheckPath(cTempPath)

// Install global handler.
DC_ReadGuiHandler({|a,b,c,d,e,f|&('DC_HelpHandler')(a,b,c,d,e,f)})
aHelpOptions[HELP_OPTIONS_HOTKEYFOCUS] := xbeK_ALT_F11    // Hot key to View Focus Item info in window
aHelpOptions[HELP_OPTIONS_HELPREQUEST] := xbeK_ALT_F1     // Hot key to send Help Request for focus item
aHelpOptions[HELP_OPTIONS_KEYBLOCK   ] := {||.t.}         // Code block to enable hot keys
aHelpOptions[HELP_OPTIONS_EDITBLOCK  ] := {||.t.}         // Code block to enable help editing
aHelpOptions[HELP_OPTIONS_FONT       ] := '10.Courier'    // Font of Help Window
aHelpOptions[HELP_OPTIONS_TITLE      ] := 'XDOT Help'    // Title of Help Window
aHelpOptions[HELP_OPTIONS_ROOT       ] := 'DESKTOP'       // Help Root Name
aHelpOptions[HELP_OPTIONS_TYPE       ] := 4               // Help Type
aHelpOptions[HELP_OPTIONS_DATABASE   ] := cDataPath + 'HELP.DBF'      // Help Database Alias Name
aHelpOptions[HELP_OPTIONS_PARENT     ] := nil             // Parent of Help Window
aHelpOptions[HELP_OPTIONS_WINHEIGHT  ] := 400             // Help Window Height
aHelpOptions[HELP_OPTIONS_WINWIDTH   ] := 620             // Help Window Width
aHelpOptions[HELP_OPTIONS_FIND       ] := cDataPath + 'HELPFIND.DBF'  // Help Find Database Alias Name
aHelpOptions[HELP_OPTIONS_EXITMODE   ] := HELP_EXITMODE_DESTROY   // Help Exit Mode
aHelpOptions[HELP_OPTIONS_SCRIPTPATH ] := cScriptPath     // Script Path
aHelpOptions[HELP_OPTIONS_HTMLPATH   ] := cHtmlPath       // HTML Path
aHelpOptions[HELP_OPTIONS_TEMPPATH   ] := cTempPath       // Temp files path

&('DC_HelpOptions')( aHelpOptions )

RETURN nil

* ------------

STATIC FUNCTION _CheckPath(cPath)

IF Empty(Directory(cPath+'*.*'))
  cPath := DC_CurPath() + '/'
ENDIF

RETURN cPath
